package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.AimTemplate;
import com.izouma.awesomeadmin.service.AimTemplateService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * controller类
 */
@Controller
@RequestMapping("/aimTemplate")
public class AimTemplateController {

    @Autowired
    private AimTemplateService aimTemplateService;

    /**
     * <p>获取全部记录。</p>
     */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(AimTemplate record) {
        List<AimTemplate> pp = aimTemplateService.getAimTemplateList(record);
        return new Result(true, pp);
    }

    /**
     * <p>根据Id。</p>
     */
    @RequestMapping(value = "/getAimTemplate", method = RequestMethod.GET)
    @ResponseBody
    public Result getAimTemplate(@RequestParam(required = false, value = "id") String id) {
        AimTemplate data = aimTemplateService.getAimTemplateById(id);
        return new Result(true, data);
    }

    /**
     * <p>根据条件获取。</p>
     */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(AimTemplate record) {
        AimTemplate data = aimTemplateService.getAimTemplate(record);
        return new Result(true, data);
    }

    @RequestMapping(value = "/getOneAllInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getOneAllInfo(AimTemplate record) {
        AimTemplate data = aimTemplateService.getAimTemplateAllInfo(record);
        return new Result(true, data);
    }


    /**
     * <p>分页查询。</p>
     */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, AimTemplate record) {
        Map<String, Object> result = new HashMap<>();

        List<AimTemplate> pp = aimTemplateService.getAimTemplateByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
     * <p>保存。</p>
     */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(AimTemplate record) {
        boolean num = aimTemplateService.createAimTemplate(record);
        if (num) {
            return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>更新信息。</p>
     */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateAimTemplate(AimTemplate record) {
        boolean num = aimTemplateService.updateAimTemplate(record);
        if (num) {
            return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
     * <p>删除。</p>
     */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteAimTemplate(AimTemplate record) {

        boolean num = aimTemplateService.deleteAimTemplate(record);
        if (num) {
            return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
     * 导出Excel
     *
     * @param request
     * @param response
     * @param record
     * @throws Exception
     */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, AimTemplate record) throws Exception {

        List<AimTemplate> aimTemplates = aimTemplateService.getAimTemplateList(record);


        String sheetName = "aim_template";
        String titleName = "点标模板数据表";
        String fileName = "点标模板表";
        int columnNumber = 10;
        int[] columnWidth = {20, 20, 20, 20, 20, 20, 20, 20, 20, 20};
        String[] columnName = {"", "删除标识", "更新时间", "更新人", "创建时间", "创建人", "模板名称", "适用于", "备注", "权限"};
        String[][] dataList = new String[aimTemplates.size()][10];

        for (int i = 0; i < aimTemplates.size(); i++) {

            dataList[i][0] = String.valueOf(aimTemplates.get(i).getId());
            dataList[i][1] = String.valueOf(aimTemplates.get(i).getDelFlag());
            dataList[i][2] = String.valueOf(aimTemplates.get(i).getUpdateTime());
            dataList[i][3] = String.valueOf(aimTemplates.get(i).getUpdateUser());
            dataList[i][4] = String.valueOf(aimTemplates.get(i).getCreateTime());
            dataList[i][5] = String.valueOf(aimTemplates.get(i).getCreateUser());
            dataList[i][6] = String.valueOf(aimTemplates.get(i).getTemplateName());
            dataList[i][7] = String.valueOf(aimTemplates.get(i).getApplyTo());
            dataList[i][8] = String.valueOf(aimTemplates.get(i).getRemark());
            dataList[i][9] = String.valueOf(aimTemplates.get(i).getPower());
        }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
                columnNumber, columnWidth, columnName, dataList, response);


    }
}

